%undefine __cmake_in_source_build
Summary:        A fast and lightweight key/value database library by Google
Name:           leveldb
Version:        1.23
Release:        1%{?dist}
License:        BSD
URL:            https://github.com/google/leveldb
Source0:        %{url}/archive/%{version}/%{name}-%{version}.tar.gz

Patch0001:      0001-Allow-leveldbjni-build.patch
Patch0002:      0002-Added-a-DB-SuspendCompations-and-DB-ResumeCompaction.patch
Patch0003:      0003-allow-Get-calls-to-avoid-copies-into-std-string.patch
Patch0004:      0004-bloom_test-failure-on-big-endian-archs.patch
Patch0006:      0006-revert-no-rtti.patch

BuildRequires:  cmake, gcc, gcc-c++
BuildRequires:  make, snappy-devel, sqlite-devel

%description
LevelDB is a fast key-value storage library written at Google that provides an
ordered mapping from string keys to string values.

%package devel
Summary:        Development files for %{name}
Requires:       cmake-filesystem
Requires:       %{name} = %{?epoch:%{epoch}:}%{version}-%{release}

%description devel
%{summary}.

%prep
%autosetup -p1

cat > %{name}.pc << EOF
prefix=%{_prefix}
exec_prefix=${prefix}
libdir=%{_libdir}
includedir=%{_includedir}

Name: %{name}
Description: %{summary}
Version: %{version}
Libs: -l%{name}
EOF

%build
%cmake -DLEVELDB_BUILD_TESTS:BOOL=OFF \
       -DLEVELDB_BUILD_BENCHMARKS:BOOL=OFF
%cmake_build

%install
%cmake_install

mkdir -p %{buildroot}%{_libdir}/pkgconfig
cp -a %{name}.pc %{buildroot}%{_libdir}/pkgconfig/

%check
%ctest

%files
%license LICENSE
%doc AUTHORS README.md NEWS
%{_libdir}/lib%{name}.so.*


%files devel
%doc doc/ CONTRIBUTING.md TODO
%{_includedir}/%{name}/
%{_libdir}/lib%{name}.so
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/cmake/%{name}/


%changelog
* Thu Dec 21 2023 Chair <chairou@tencent.com> - 1.23-1
- Init
